<?php
/*
* jQuery Arfaly Plugin; v20141015
* http://www.itechflare.com/
* Copyright (c) 2014 iTechFlare; Licensed: Commercial
* Version : v1.5.6
* http://mihanscript.ir/
* Developer: http://mihanscript.ir/
*/

// Sanitize the whole input
$_POST  = filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

############ Global settings ##############

$localFileDestination		= 'uploads/'; // From server side, define the uploads folder url 
$maxFileSize 			= 1024 * 1024 * 10; // Max 10MB
$fileNameFormat				= ''; // By given a string here, you will allow all of the filename to be formated as 'fileNameFormat-time-xxx.ext', where xxx are random generated numbers

$allowedExts 			= array( // Change this list to allow more files to be uploaded :)
	"gif", 
	"jPeg", 
	"jpg", 
	"png", 
	"avi", 
	"mp3", 
	"wav", 
	"mp4", 
	"dOc", 
	"docX", 
	"pdf",
	"txt",
	"zip", 
	"rar"
);

########################################

// Check if it is a delete command
if(isset($_POST['command']) && $_POST['command']=='delete')
{
	if(!isset($_POST['arfaly-filename']))
	{
		$json['msg'] = "File not found";
		$json['status'] = 'false';
		
		echo json_encode($json);
		die();
	}
	// Handle file deletion here
	DeleteFileByName($_POST['arfaly-filename']);
	
	echo $_POST['arfaly-filename'].' Has been deleted. For security porpuses, please customize and sanitize deletion for your application!';
	die();
}

// Create uploads folder if doesn't exist
if (!file_exists($localFileDestination)) {
	mkdir($localFileDestination, 0766, true);
}

$temp = explode(".", $_FILES["SelectedFile"]["name"]);

// Enforce extensions to be converted into lower case
$allowedExts = array_map('strtolower', $allowedExts);

// Business Logic
$extension = end($temp);
$allowedE = false;
$allowedS = false;
$json = array(
	"status" => 'false',
);

$extension = strtolower($extension);
$extension = trim($extension, " ");

// Check extension
if(in_array($extension,$allowedExts)){
	$allowedE = true;
}
else
{
	$json['msg'] = $_FILES["SelectedFile"]["type"].": Invalid file type!";
}
	
if($_FILES["SelectedFile"]["size"] < $maxFileSize)
{
	$allowedS = true;
}else{
	$json['msg'] = "File size has exceeded the limit (".$maxFileSize.")!";
}

if( $allowedE && $allowedS)
{
  if ($_FILES["SelectedFile"]["error"] > 0) {
    $json['msg'] = "Return Code: " . $_FILES["SelectedFile"]["error"];
  } else {
    if (!file_exists($localFileDestination . time()."-".$_FILES["SelectedFile"]["name"] )) {
	  $filename = pathinfo($_FILES["SelectedFile"]["name"],PATHINFO_FILENAME);
	  $extension = pathinfo($_FILES["SelectedFile"]["name"],PATHINFO_EXTENSION);
	  
	  // Changing filename
	  if($fileNameFormat == '')
		$newname = $filename . "-". time() . '-' .rand(10,1000)."." . $extension;  
	  else
		$newname = $fileNameFormat . "-". time() . '-' .rand(10,1000)."." . $extension;  
	  
      move_uploaded_file($_FILES["SelectedFile"]["tmp_name"], $localFileDestination . $newname);
	  
      $json['status'] = 'true';
	  $json['msg'] = $_FILES["SelectedFile"]["name"].' Has been successfully uploaded!';
	  $json['newFileName'] = $newname;
	  $json['fullPath'] = $localFileDestination . $newname;
    }else{
		$json['msg'] = 'File already exist!';
	}
  }
}

function DeleteFileByName($fileName)
{
	// Please handle deletion safely, as this part could be exploited by hackers
	global $localFileDestination;
	$files = glob($localFileDestination.$fileName); // get all file names
	
	foreach($files as $file){ // iterate files
		if(is_file($file))
			unlink($file); // delete file
	}
}

// Print out results
echo json_encode($json);
die();

?>